apiVersion: apps/v1
kind: Deployment
metadata:
  name: odoo
  namespace: legacy
  labels:
    app: odoo
spec:
  replicas: 1
  selector:
    matchLabels:
      app: odoo
  template:
    metadata:
      labels:
        app: odoo
    spec:
      affinity:
        podAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchLabels:
                app: odoo
            topologyKey: kubernetes.io/hostname
      
      containers:
      # - image: busybox
      #   name: prep
      #   volumeMounts:
      #   - mountPath: /mnt/odoo-data/
      #     name: odoo-data-v
      #   command: ["sleep", "99999"]
      #   resources: {}
      
      - name: odoo
        ports:
        - containerPort: 8069
          protocol: TCP
        image: registry.gitlab.com/agepoly/it/dev/odoo:a76b3303
        imagePullPolicy: IfNotPresent
        
        env:
        - name: SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: SECRET_KEY
              name: odoo-env-secrets
        - name: SINGLE_DB_NAME
          valueFrom:
            secretKeyRef:
              key: SINGLE_DB_NAME
              name: odoo-env-secrets
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: DB_USER
              name: odoo-env-secrets
        - name: DB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: DB_PASSWORD
              name: odoo-env-secrets
        - name: FINTECH_REGISTER_NAME
          valueFrom:
            secretKeyRef:
              key: FINTECH_REGISTER_NAME
              name: odoo-env-secrets
        - name: FINTECH_REGISTER_KEYCODE
          valueFrom:
            secretKeyRef:
              key: FINTECH_REGISTER_KEYCODE
              name: odoo-env-secrets
        - name: FINTECH_REGISTER_USERS
          valueFrom:
            secretKeyRef:
              key: FINTECH_REGISTER_USERS
              name: odoo-env-secrets
        - name: DB_HOST
          value: databases
        - name: HOST
          value: odoo.agepoly.ch:compta.agepoly.ch
        
        volumeMounts:
        - mountPath: /var/lib/odoo
          name: odoo-data-v

        livenessProbe:
          failureThreshold: 2
          httpGet:
            httpHeaders:
            - name: Host
              value: odoo.agepoly.ch
            path: /
            port: 8069
            scheme: HTTP
          initialDelaySeconds: 300
          periodSeconds: 300
          successThreshold: 1
          timeoutSeconds: 30
        
        readinessProbe:
          failureThreshold: 1
          httpGet:
            httpHeaders:
            - name: Host
              value: odoo.agepoly.ch
            path: /
            port: 8069
            scheme: HTTP
          initialDelaySeconds: 5
          periodSeconds: 150
          successThreshold: 1
          timeoutSeconds: 30
        
        startupProbe:
          failureThreshold: 30
          httpGet:
            httpHeaders:
            - name: Host
              value: odoo.agepoly.ch
            path: /
            port: 8069
            scheme: HTTP
          initialDelaySeconds: 5
          periodSeconds: 10
          successThreshold: 1
          timeoutSeconds: 50

        resources: {}
      initContainers:
      - command:
        - sh
        - -c
        - chown -R 101:101 /var/lib/odoo
        image: busybox
        name: init-container
        resources: {}
        volumeMounts:
        - mountPath: /var/lib/odoo
          name: odoo-data-v
      volumes:
      - name: odoo-data-v
        persistentVolumeClaim:
          claimName: odoo-data-pvc


---
kind: PersistentVolumeClaim
apiVersion: v1
metadata:
  name: odoo-data-pvc
  namespace: legacy
spec:
  storageClassName: hdd-r3
  accessModes:
  - ReadWriteOnce
  resources:
    requests:
      storage: 10Gi


---
apiVersion: v1
kind: Service
metadata:
  name: odoo
  namespace: legacy
  labels:
    app: odoo
spec:
  ports:
  - port: 80
    targetPort: 8069
    protocol: TCP
    name: http
  selector:
    app: odoo
  type: ClusterIP
  
---
apiVersion: gateway.networking.k8s.io/v1beta1
kind: HTTPRoute
metadata:
  name: odoo
  namespace: legacy
spec:
  parentRefs:
  - name: vip-240
    sectionName: main
    namespace: istio-system
  hostnames: ["odoo.agepoly.ch"]
  rules:
  - matches:
    - path:
        type: PathPrefix
        value: /
    backendRefs:
    - name: odoo
      port: 80

---
apiVersion: gateway.networking.k8s.io/v1beta1
kind: HTTPRoute
metadata:
  name: odoo-vente
  namespace: legacy
spec:
  parentRefs:
  - name: vip-240
    sectionName: main
    namespace: istio-system
  hostnames: ["vente.agepoly.ch"]
  rules:
  - matches:
    - path:
        type: PathPrefix
        value: /
    backendRefs:
    - name: odoo
      port: 80

---
apiVersion: gateway.networking.k8s.io/v1beta1
kind: HTTPRoute
metadata:
  name: odoo-compta
  namespace: legacy
spec:
  parentRefs:
  - name: vip-240
    sectionName: main
    namespace: istio-system
  hostnames: ["compta.agepoly.ch"]
  rules:
  - matches:
    - path:
        type: PathPrefix
        value: /
    backendRefs:
    - name: odoo
      port: 80
